/**
 * δ
 * activityû༭fail safe  עSharedPreferenceҪ??
 */
package glzt.wifi.control;

import glzt.util.ConstantData;
import glzt.util.jni.JniEngine;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStreamWriter;
import java.net.Socket;
import java.util.Timer;
import java.util.TimerTask;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Color;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.View;
import android.view.View.OnLongClickListener;
import android.view.Window;
import android.view.WindowManager;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.SeekBar;
import android.widget.SeekBar.OnSeekBarChangeListener;
import android.widget.TextView;
import android.widget.Toast;

public class FailsafeEditActivity 
 extends Activity 
 implements OnClickListener, OnSeekBarChangeListener,OnLongClickListener {

	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle safedInstanceState) {  
    	super.onCreate(safedInstanceState);
    	this.requestWindowFeature(Window.FEATURE_NO_TITLE);//ȥ⣨Ӧõ) 
		//趨ҪдsetContentView֮ǰ쳣
		this.getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
		setContentView(R.layout.edit_failsafe);	
    }

	@Override
	protected void onResume(){
		findView();
		super.onResume();
	}
    
	private void findView(){		
		
		//õactivityʱ
        Intent intent = this.getIntent();  
        //õ   
        activityName = intent.getStringExtra("fromActivity");
        if(!activityName.equals("WifiControlActivity")){
        	//Log.e("FailsafeEdit","from Activity error,from:"+activityName);
        }
               
		btnApply = (Button)findViewById(R.id.btnApply);
        btnApply.setOnClickListener(this);
        
        btnBack = (Button)findViewById(R.id.btnBack);
        btnBack.setOnClickListener(this);
        
        btnZero = (Button)findViewById(R.id.btnZero);
        btnZero.setOnClickListener(this);
        
        tvValue[0] = (TextView)findViewById(R.id.tvChn1Value);
        tvValue[1] = (TextView)findViewById(R.id.tvChn2Value);
        tvValue[2] = (TextView)findViewById(R.id.tvChn3Value);
        tvValue[3] = (TextView)findViewById(R.id.tvChn4Value);
        
        sbFailsafe[0] = (SeekBar)findViewById(R.id.sbFailsafeChn1);
        sbFailsafe[1] = (SeekBar)findViewById(R.id.sbFailsafeChn2);
        sbFailsafe[2] = (SeekBar)findViewById(R.id.sbFailsafeChn3);
        sbFailsafe[3] = (SeekBar)findViewById(R.id.sbFailsafeChn4);        
        
        btnLeft[0] = (Button)findViewById(R.id.btnChn1Left);
        btnLeft[1] = (Button)findViewById(R.id.btnChn2Left);
        btnLeft[2] = (Button)findViewById(R.id.btnChn3Left);
        btnLeft[3] = (Button)findViewById(R.id.btnChn4Left);
        
        btnRight[0] = (Button)findViewById(R.id.btnChn1Right);
        btnRight[1] = (Button)findViewById(R.id.btnChn2Right);
        btnRight[2] = (Button)findViewById(R.id.btnChn3Right);
        btnRight[3] = (Button)findViewById(R.id.btnChn4Right);
        for(int i=0;i<ConstantData.MAX_CHANNEL_NUM;i++){
        	sbFailsafe[i].setOnClickListener(this);
        	sbFailsafe[i].setMax(SEEK_BAR_MAX);
        	sbFailsafe[i].setOnSeekBarChangeListener(this);
        	btnLeft[i].setOnClickListener(this);
        	btnLeft[i].setOnLongClickListener(this);
        	btnRight[i].setOnClickListener(this);
        	btnRight[i].setOnLongClickListener(this);
        }
        
        //ȴappȡ,ûнջϢ,ŷϢȥջȡ
        app = (ConnectWifiApplication)this.getApplication();
        socket = app.getCurServerSocket();
        isConnected = app.getIsWifiConnected();
        String tmpSSID = app.getSSID();
        String tmpPWD = app.getPassword();
        failSafeValue = app.getFailsafe();
        if((null!=tmpSSID)&&(null!=tmpPWD)&&
        		(ConstantData.INVALID_VALUE!=failSafeValue[0])&&
        		(ConstantData.INVALID_VALUE!=failSafeValue[1])&&
        		(ConstantData.INVALID_VALUE!=failSafeValue[2])&&
        		(ConstantData.INVALID_VALUE!=failSafeValue[3])){
        	// ֱϢƸhandler,ͬյջϢĴ
        	msg= new Message();
    		msg.what = MSG_GET_RECV_INFO;
    		msg.getData().putString("recvData", 
    								"Rxinfo:"+
    								tmpSSID+","+
    								tmpPWD+","+
    								String.valueOf(failSafeValue[0])+","+
    								String.valueOf(failSafeValue[1])+","+
    								String.valueOf(failSafeValue[2])+","+
    								String.valueOf(failSafeValue[3])
    								);
    		handlerConnectMsg.sendMessage(msg);
        }else{
        	//Log.d("failsafe","no valid failsafe data");
        	setZero();
        }
	}	
	
	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		if(btnApply == v){
			String msgToSend;
			int progress;
			for(int i=0;i<ConstantData.MAX_CHANNEL_NUM;i++){
				progress = sbFailsafe[i].getProgress();
				failSafeValue[i]=ZERO_VALUE + (progress-SEEK_BAR_OFFSET)*SCALE_VALUE/SEEK_BAR_OFFSET;
			}
	    	
	    	// ʼջ,µfailsafe
	    	// ʽ: #3,&CH1=1500&CH2=1500&CH3=1500&CH4=1500&#

			// ڶλ3ûƣҪȱ& =ַCHǴд
	    	msgToSend = "#3,&CH1=" +failSafeValue[0]+
	    				   "&CH2=" +failSafeValue[1]+
	    				   "&CH3=" +failSafeValue[2]+
	    				   "&CH4=" +failSafeValue[3]+"&#";

	    	if((socket != null)&&(isConnected)){
		    	try {
					sendMsg(socket,msgToSend);
					//ͳɹ,app
			    	if(!app.setFailsafe(failSafeValue, ConstantData.MAX_CHANNEL_NUM)){
						//Log.e("setfailsafe","failed cause of invalid value");
			    	}
				} catch (IOException e) {
					// TODO Auto-generated catch block
					// toast
					e.printStackTrace();
					Toast.makeText(FailsafeEditActivity.this, 
        					"Cannot Set Failsafe... " +
        					"Receiver disconnected, try to connect again or restart Receiver", 
        					Toast.LENGTH_LONG).show();
				}		    	
	    	}else{
	    		Toast.makeText(FailsafeEditActivity.this, 
    					"Cannot Set Failsafe... " +
    					"Receiver disconnected, try to connect again or restart Receiver", 
    					Toast.LENGTH_LONG).show();
	    	}	    	
		}else if(btnBack == v){
			Intent intent0 = new Intent(FailsafeEditActivity.this, WifiControlActivity.class);
			Bundle bundle = new Bundle(); 
            bundle.putString("fromActivity", "FailsafeEditActivity"); 
            intent0.putExtras(bundle);
			startActivity(intent0);	
		}else if(btnZero == v){
			setZero();
		}else if(btnLeft[0] == v){
			int progress;
			progress = sbFailsafe[0].getProgress();
			if(progress>0){
				sbFailsafe[0].setProgress(progress-1);
				tvValue[0].setText(String.valueOf((int)(100*((float)(progress-1-SEEK_BAR_OFFSET)/SEEK_BAR_OFFSET)))+"%");
			}			
		}else if(btnLeft[1] == v){
			int progress;
			progress = sbFailsafe[1].getProgress();
			if(progress>0){
				sbFailsafe[1].setProgress(progress-1);
				tvValue[1].setText(String.valueOf((int)(100*((float)(progress-1-SEEK_BAR_OFFSET)/SEEK_BAR_OFFSET)))+"%");
			}			
		}else if(btnLeft[2] == v){
			int progress;
			progress = sbFailsafe[2].getProgress();
			if(progress>0){
				sbFailsafe[2].setProgress(progress-1);
				tvValue[2].setText(String.valueOf((int)(100*((float)(progress-1-SEEK_BAR_OFFSET)/SEEK_BAR_OFFSET)))+"%");
			}			
		}else if(btnLeft[3] == v){
			int progress;
			progress = sbFailsafe[3].getProgress();
			if(progress>0){
				sbFailsafe[3].setProgress(progress-1);
				tvValue[3].setText(String.valueOf((int)(100*((float)(progress-1-SEEK_BAR_OFFSET)/SEEK_BAR_OFFSET)))+"%");
			}			
		}else if(btnRight[0] == v){
			int progress;
			progress = sbFailsafe[0].getProgress();
			if(progress<SEEK_BAR_MAX){
				sbFailsafe[0].setProgress(progress+1);
				tvValue[0].setText(String.valueOf((int)(100*((float)(progress+1-SEEK_BAR_OFFSET)/SEEK_BAR_OFFSET)))+"%");
			}			
		}else if(btnRight[1] == v){
			int progress;
			progress = sbFailsafe[1].getProgress();
			if(progress<SEEK_BAR_MAX){
				sbFailsafe[1].setProgress(progress+1);
				tvValue[1].setText(String.valueOf((int)(100*((float)(progress+1-SEEK_BAR_OFFSET)/SEEK_BAR_OFFSET)))+"%");
			}			
		}else if(btnRight[2] == v){
			int progress;
			progress = sbFailsafe[2].getProgress();
			if(progress<SEEK_BAR_MAX){
				sbFailsafe[2].setProgress(progress+1);
				tvValue[2].setText(String.valueOf((int)(100*((float)(progress+1-SEEK_BAR_OFFSET)/SEEK_BAR_OFFSET)))+"%");
			}			
		}else if(btnRight[3] == v){
			int progress;
			progress = sbFailsafe[3].getProgress();
			if(progress<SEEK_BAR_MAX){
				sbFailsafe[3].setProgress(progress+1);
				tvValue[3].setText(String.valueOf((int)(100*((float)(progress+1-SEEK_BAR_OFFSET)/SEEK_BAR_OFFSET)))+"%");
			}			
		}
		setTextviewColor();
	}

	@Override
	public boolean onLongClick(View v) {
		if(btnLeft[0] == v){
			setTimer(btnLeft[0]);
		}else if(btnLeft[1] == v){
			setTimer(btnLeft[1]);
		}else if(btnLeft[2] == v){
			setTimer(btnLeft[2]);
		}else if(btnLeft[3] == v){
			setTimer(btnLeft[3]);
		}else if(btnRight[0] == v){
			setTimer(btnRight[0]);
		}else if(btnRight[1] == v){
			setTimer(btnRight[1]);
		}else if(btnRight[2] == v){
			setTimer(btnRight[2]);
		}else if(btnRight[3] == v){
			setTimer(btnRight[3]);
		}
		return false;
	}
	
    @Override
	protected void onDestroy() {
    	if(mReceiveThread != null){
    		stopRecvMsg = true;
    	}
    	super.onDestroy();
	}
	
    @Override  
    protected void onPause()   
    {  
    	if(mReceiveThread != null){
    		stopRecvMsg = true;
    	}
        super.onPause();  
    }

	@Override
	public void onProgressChanged(SeekBar seekBar, int progress,
			boolean fromUser) {
		// TODO Auto-generated method stub
		int showData = (int)(100*((float)(progress-SEEK_BAR_OFFSET)/SEEK_BAR_OFFSET));
		if(sbFailsafe[0]==seekBar){
			sbFailsafe[0].setProgress(progress);
			tvValue[0].setText(String.valueOf(showData)+"%");			
		}if(sbFailsafe[1]==seekBar){
			sbFailsafe[1].setProgress(progress);
			tvValue[1].setText(String.valueOf(showData)+"%");
		}if(sbFailsafe[2]==seekBar){
			sbFailsafe[2].setProgress(progress);
			tvValue[2].setText(String.valueOf(showData)+"%");
		}if(sbFailsafe[3]==seekBar){
			sbFailsafe[3].setProgress(progress);
			tvValue[3].setText(String.valueOf(showData)+"%");
		}
		setTextviewColor();
	}

	@Override
	public void onStartTrackingTouch(SeekBar seekBar) {
		// TODO Auto-generated method stub		
	}

	@Override
	public void onStopTrackingTouch(SeekBar seekBar) {
		// TODO Auto-generated method stub		
	}	
	
    
    /*ϢwifiԶ
	 * @param Socket socket, the socket that can send msg out
	 * @param String Msg, message to be send
	 */
	private void sendMsg(Socket socket,String Msg) throws IOException 
	{
		if(socket.isConnected()){
			writer = new BufferedWriter(
					new OutputStreamWriter(socket.getOutputStream()));
			writer.write(Msg); // ִʱעⲻ\n
			writer.flush();
		}else{
			//Log.d("sendMsg failsafe","send message failed due to socket is not connected");
		}
	}
    
    
	private class ReceiveThread extends Thread
	{
	    private InputStream inStream = null;
	    
	    private byte[] buf;  
	    //private String str = null;
	    
	    ReceiveThread(Socket s)
	    {
	        try {
	            //
	            this.inStream = s.getInputStream();		            
	        } catch (IOException e) {
	            e.printStackTrace();
	        }
	    }      
	    
	    @Override
	    public void run()
	    {
	        while(!stopRecvMsg)
	        {
	            this.buf = new byte[512];
	            if((null != app.getCurServerSocket())&&(null != this.inStream))
	            {
	            	try {
	            		//ȡݣ
	            		while(-1 != this.inStream.read(this.buf)){
		            		// жϻõϢ, յջSSID/PWDϢ,Ϣhandler
		            		recvData=new String(this.buf,"UTF-8").trim();
		            		//recvData = this.buf.toString().trim();
		            		if(recvData.contains("Rxinfo:")){
			            		msg= new Message();
			            		msg.what = MSG_GET_RECV_INFO;
			            		msg.getData().putString("recvData", recvData);
			            		handlerConnectMsg.sendMessage(msg);
			            		//Log.i("buf",buf.toString().trim());
		            		}
	            		}
	            	} catch (IOException e) {
	            		e.printStackTrace();
	            	} 
	            }else{
	            	stopRecvMsg = true;
	            	//if(null == this.inStream)
	            		//Log.e("inStream null","inStream null");
	            	break;
	            }
		    	
		    	// ÿ100msһ߳
		    	try {
					Thread.sleep(100);
				} catch (Exception ex) {
				}
	        }
	        
	        /*
	        if((stopRecvMsg)&&(null != this.inStream)){
				try {
					this.inStream.close();
					Log.i("inStream closed","Failsafe");
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
	        }
	        */
	    }  
	}
	
	Handler handlerConnectMsg = new Handler() {
		public void handleMessage(Message msg) {
			switch(msg.what) {
				case MSG_GET_RECV_INFO:
					String text = msg.getData().getString("recvData");
					
					// ȡSSID/PWDϢ,app
					int ssid=0,pwd=1,macCypherHex=6,superCypherHex=7;//ch1=2,ch2=3,ch3=4,ch4=5,
					int progress;
					receiverInfo = getRecvData(text);
					SSID = receiverInfo[ssid];
					PWD = receiverInfo[pwd];
					for(int i=0;i < ConstantData.MAX_CHANNEL_NUM;i++){
						failSafeValue[i]=Integer.parseInt(receiverInfo[i+2]);
						progress = (int)((((float)failSafeValue[i]-ZERO_VALUE)/SCALE_VALUE)*SEEK_BAR_OFFSET);						
						sbFailsafe[i].setProgress(progress+SEEK_BAR_OFFSET);
						tvValue[i].setText(String.valueOf((int)(100*((float)progress/SEEK_BAR_OFFSET)))+"%");
					}

					setTextviewColor();
					app.setRecvInfo(SSID, PWD);
					app.setFailsafe(failSafeValue, ConstantData.MAX_CHANNEL_NUM);
					
					break;
			}
			super.handleMessage(msg);
		}
	};


	/**
	 * ȡջssid,password,fail safeϢ
	 * @param recvData
	 * @return String[6],ssid,pwd,failsafe1,failsafe2,failsafe3,failsafe4
	 */
	private String[] getRecvData(String recvData){
		String tmpstr = recvData;
		int index,idxBegin,idxEnd;
		// recvDataʽӦΪ: "Rxinfo:ssid,key,1500,1500,1500,1500"
		index = tmpstr.indexOf(":");
		if(-1 == index){
			// Ҳ
			//Log.d("recv msg process","failed to find RX info prefix");
			return null;
		}
		idxBegin = index+1;
		String strArray[]= new String[6];
		int j;
		for(j=0;j<6;j++){
			idxEnd=tmpstr.indexOf(",",idxBegin);
			if(-1==idxEnd){
				idxEnd = tmpstr.length();
				strArray[j]=tmpstr.substring(idxBegin,idxEnd);
				break;
			}
			strArray[j]=tmpstr.substring(idxBegin,idxEnd);
			
			idxBegin = idxEnd+1;				
		}
		if(5>j){
			//Log.e("getSSIDFromRecvMsg","failed to find RX info ");
			return null;
		}
		return strArray;
	}
	
	private void setZero(){		
		for(int i=0;i < ConstantData.MAX_CHANNEL_NUM;i++){
			sbFailsafe[i].setProgress(SEEK_BAR_OFFSET);
			tvValue[i].setText("0%");
			tvValue[i].setTextColor(Color.WHITE);
			tvValue[i].invalidate();
			sbFailsafe[i].invalidate();
		}
	}

	private void setTextviewColor(){
		int progress;
		for(int i=0;i < ConstantData.MAX_CHANNEL_NUM;i++){
			progress = sbFailsafe[i].getProgress();			
			if(SEEK_BAR_OFFSET<progress){
				tvValue[i].setTextColor(Color.GREEN);
			}else if(SEEK_BAR_OFFSET>progress){
				tvValue[i].setTextColor(Color.RED);
			}else{
				tvValue[i].setTextColor(Color.WHITE);
			}
		}
	}
	

	Handler handlerFSBar = new Handler() {
		public void handleMessage(Message msg) {
			int progress;
			switch(msg.what) {
				case LEFT0:
					progress = sbFailsafe[0].getProgress();
					if(progress>0){
						sbFailsafe[0].setProgress(progress-1);
						tvValue[0].setText(String.valueOf((int)(100*((float)(progress-1-SEEK_BAR_OFFSET)/SEEK_BAR_OFFSET)))+"%");
					}
	    	        break;
				case LEFT1:
					progress = sbFailsafe[1].getProgress();
					if(progress>0){
						sbFailsafe[1].setProgress(progress-1);
						tvValue[1].setText(String.valueOf((int)(100*((float)(progress-1-SEEK_BAR_OFFSET)/SEEK_BAR_OFFSET)))+"%");
					}
					break;
				case LEFT2:
					progress = sbFailsafe[2].getProgress();
					if(progress>0){
						sbFailsafe[2].setProgress(progress-1);
						tvValue[2].setText(String.valueOf((int)(100*((float)(progress-1-SEEK_BAR_OFFSET)/SEEK_BAR_OFFSET)))+"%");
					}
					break;
				case LEFT3:
					progress = sbFailsafe[3].getProgress();
					if(progress>0){
						sbFailsafe[3].setProgress(progress-1);
						tvValue[3].setText(String.valueOf((int)(100*((float)(progress-1-SEEK_BAR_OFFSET)/SEEK_BAR_OFFSET)))+"%");
					}
					break;
				case RIGHT0:
					progress = sbFailsafe[0].getProgress();
					if(progress<SEEK_BAR_MAX){
						sbFailsafe[0].setProgress(progress+1);
						tvValue[0].setText(String.valueOf((int)(100*((float)(progress+1-SEEK_BAR_OFFSET)/SEEK_BAR_OFFSET)))+"%");
					}
					break;
				case RIGHT1:
					progress = sbFailsafe[1].getProgress();
					if(progress<SEEK_BAR_MAX){
						sbFailsafe[1].setProgress(progress+1);
						tvValue[1].setText(String.valueOf((int)(100*((float)(progress+1-SEEK_BAR_OFFSET)/SEEK_BAR_OFFSET)))+"%");
					}
					break;
				case RIGHT2:
					progress = sbFailsafe[2].getProgress();
					if(progress<SEEK_BAR_MAX){
						sbFailsafe[2].setProgress(progress+1);
						tvValue[2].setText(String.valueOf((int)(100*((float)(progress+1-SEEK_BAR_OFFSET)/SEEK_BAR_OFFSET)))+"%");
					}
					break;
				case RIGHT3:
					progress = sbFailsafe[3].getProgress();
					if(progress<SEEK_BAR_MAX){
						sbFailsafe[3].setProgress(progress+1);
						tvValue[3].setText(String.valueOf((int)(100*((float)(progress+1-SEEK_BAR_OFFSET)/SEEK_BAR_OFFSET)))+"%");
					}
					break;
			}
			super.handleMessage(msg);
		}
	};
	
	private void setTimer(final Button btn){
		final Timer t = new Timer();
        TimerTask tt = new TimerTask(){
            @Override
            public void run(){
                if(btn.isPressed()){
                	Message message = new Message();
                	if(btnLeft[0] == btn){
                 	   message.what = LEFT0;
                 	}else if(btnLeft[1] == btn){
                 	   message.what = LEFT1;
                 	}else if(btnLeft[2] == btn){
                 	   message.what = LEFT2;
                 	}else if(btnLeft[3] == btn){
                 	   message.what = LEFT3;
                 	}else if(btnRight[0] == btn){
                 	   message.what = RIGHT0;
                 	}else if(btnRight[1] == btn){
                 	   message.what = RIGHT1;
                 	}else if(btnRight[2] == btn){
                 	   message.what = RIGHT2;
                 	}else if(btnRight[3] == btn){
                  	   message.what = RIGHT3;
                  	}
                	handlerFSBar.sendMessage(message);	                	
                }else{
                	t.cancel();
            	}
            }
        };        
        t.schedule(tt, 50, 50);
	}

	/** 
	 * 򵥶Իʵ
	 * @param title  String
	 * @param info   ԻʾString
	 */
	private void simpleDialog(String title,String info){		
		builder = new AlertDialog.Builder(FailsafeEditActivity.this);  
		builder.setTitle(title); 
		builder.setMessage(info); 
		
		builder.setPositiveButton("OK",
				new DialogInterface.OnClickListener() {
			        public void onClick(DialogInterface dialog,int whichButton){
                    dialog.cancel();}
			    });
		alertDialog = builder.create();  
		alertDialog.show();
	}

	JniEngine jniEngineFs = new JniEngine();
	
	protected static final int MSG_GET_RECV_INFO = 9;
 	protected static final int MSG_TMP_1 = 1;
 	
 	protected static final int SEEK_BAR_MAX = 200;
 	protected static final int SEEK_BAR_OFFSET = 100;
 	protected static final int ZERO_VALUE=1500;
 	protected static final int SCALE_VALUE=500;
 	
 	// message handleró:
 	protected static final int LEFT0 = 3000;
 	protected static final int LEFT1 = 3001;
 	protected static final int LEFT2 = 3002;
 	protected static final int LEFT3 = 3003;
 	protected static final int RIGHT0 = 3004;
 	protected static final int RIGHT1 = 3005;
 	protected static final int RIGHT2 = 3006;
 	protected static final int RIGHT3 = 3007;
	   
	private Button btnApply,btnBack,btnZero;
	private TextView tvValue[]=new TextView[ConstantData.MAX_CHANNEL_NUM];
	private Button btnLeft[] = new Button[ConstantData.MAX_CHANNEL_NUM];
	private Button btnRight[] = new Button[ConstantData.MAX_CHANNEL_NUM];
	private SeekBar sbFailsafe[]=new SeekBar[ConstantData.MAX_CHANNEL_NUM];
	
	private int failSafe[] = new int[ConstantData.MAX_CHANNEL_NUM];
	
	
	private AlertDialog.Builder builder;   
	private AlertDialog alertDialog;	
	
	private ConnectWifiApplication app;
	private Socket socket;	
	private BufferedWriter writer;
	private boolean isConnected;
	private String activityName;
	
	// ߳ʹñ
	private String recvData = "";
	private Message msg;
 	private boolean stopRecvMsg = true;
 	private ReceiveThread mReceiveThread = null;
 	
 	// ĽջϢ 6Ϊӿڶݸ:SSID,PWD,⻹4ͨfail safeֵ
 	private String receiverInfo[] = new String[8]; 
 	private String SSID="",PWD="";
 	private int failSafeValue[] = new int[ConstantData.MAX_CHANNEL_NUM];
	
}
