package glzt.wifi.control;

import glzt.util.ConnectData;
import glzt.util.ProfileList;
import glzt.util.ConstantData;
import glzt.util.jni.JniEngine;

import glzt.util.WifiAdmin;
import android.net.wifi.ScanResult;
import android.net.wifi.WifiConfiguration;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;

import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStreamWriter;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.Socket;
import java.net.UnknownHostException;
import java.util.Date;
import java.util.List;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Color;
import android.net.ConnectivityManager;
import android.net.NetworkInfo.State;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.view.View.OnClickListener;

import android.widget.Button;
import android.widget.ProgressBar;
import android.widget.TextView;
import android.widget.Toast;

// 棬䵱ýá
// ҪʵҪásocketactivity֮δݣ ͨapplication

public class WifiControlActivity extends Activity implements OnClickListener {
	private Button btnEnterProfCfg,btnPlay,btnExit,btnRefresh,btnInstruction;//
	private Button btnEnterRecvEdit,btnEnterFailsafeEdit; //
	private TextView tvIsConn,tvCurrentProfileName;	//
	private ProgressBar pbConnecting;//
	
	private AlertDialog.Builder builder;   //
	private AlertDialog alertDialog;	//
	
	private ConnectWifiApplication app;
 	private static ProfileList currentPL = new ProfileList();
 	
 	private Intent intent;
 	private String activityName;
 	
	private Socket socket;	 // TCPӷʽҪsocket
	//private DatagramSocket udpSocket; // UDPӷʽҪsocket

	// wifi߳
	private Thread threadApplySocket;
	private boolean isApplySocketThread = false; // wifiӵ̱߳. Ϊtrueʱ,߳,wifi
	private boolean isWifiOn = false;
	private boolean isSocketConnected = false; // ʾǷɹsocketӶԶˡ˱ǱҪ߶
	
	private boolean enterWithoutWifi = false; // Ϊtrueʱʾwifi
	//֤ر
	//private boolean isVerified = false;//֤ͨΪtrue
	private String tmpKey = new String("12345678");
		
	private byte[] waitWifiLock = new byte[0];		// ͬ
	private byte[] waitSocketLock = new byte[0];    // ͬ
	private byte[] waitVerifyLock = new byte[0];    // ͬ
	
	// ʹñ
	private BufferedWriter writer;
	
	// ߳ʹñ
	private String recvData = "";
	private Message msg;
 	private boolean stopRecvMsg = true;
 	private ReceiveThread mReceiveThread = null;
 	private int recvNullCount=0;
	 	
 	// ĽջϢ 6Ϊӿڶݸ:SSID,PWD,⻹4ͨfail safeֵ
  	private String receiverInfo[] = new String[8]; 
  	private String SSID="",PWD="",strMacCypherHex,strSuperCypherHex;
  	private int failSafeValue[] = new int[ConstantData.MAX_CHANNEL_NUM];
  	
  	//JniEngine jniEngineMain = new JniEngine();
	/*
	//wifi״̬̱߳
	private Thread threadWifiMon;
	private boolean isWifiMonitorOn = false;
	private WifiAdmin mWifiAdmin;
	// wifiϢر
	WifiManager wifiManager;
	private List<WifiConfiguration> listCfgResult;  
    //private ScanResult mScanResult;
	private WifiConfiguration cfgResult;
	*/
  	
	Handler handlerConnectMsg = new Handler() {
		public void handleMessage(Message msg) {
			String text = new String();
			switch(msg.what) {
				case ConstantData.CONNECT_STATUS:
					boolean flag = msg.getData().getBoolean("isConnect");
					if(flag){
						// ӳɹϢ
						pbConnecting.setVisibility(View.INVISIBLE);
						btnRefresh.setVisibility(View.VISIBLE);
						pbConnecting.invalidate();
						btnRefresh.invalidate();
						isApplySocketThread = false;
						if(threadApplySocket!=null){
							threadApplySocket.interrupt();
						}
						
						tvIsConn.setTextColor(Color.GREEN);
				        tvIsConn.setText("Connected.");
				        
				        isSocketConnected = true;
				        
				        // Ѿϣ֤3֤̣1ӽջȡ֤ϢջϢfailsafe.¼յϢ
						if((socket != null)&&(isSocketConnected)){
				        	// Ѿӽջ,Ϣ,Ϣ߳,ȡջSSID/PWDϢ
				        	// 1. ȷϢ: "12345678"Ϊ ֤
							//tmpKey = 12345678
				        	String sendMsg = "#1,"+tmpKey+"#";// 룬Ҫĳʱݣ統ǰʱ䡣
//				        	try {
//								//sendMsg(socket,sendMsg);
//							} catch (IOException e) {
//								//Log.e("send msg","fail to send, socket="+String.valueOf(socket));
//								e.printStackTrace();
//							}
				        	// 2. Ϣ߳:
				        	mReceiveThread = new ReceiveThread(socket);
				        	stopRecvMsg = false;
				        	mReceiveThread.start();
						}
							
					}else{
						//ʧ
						//Toast.makeText(WifiControlActivity.this, 
		    			//		"Connect failed...", 
		    			//		Toast.LENGTH_LONG).show();
						
						pbConnecting.setVisibility(View.INVISIBLE);
						btnRefresh.setVisibility(View.VISIBLE);
						pbConnecting.invalidate();
						btnRefresh.invalidate();
						isApplySocketThread = false;
						if(threadApplySocket!=null){
							threadApplySocket.interrupt();
						}
						tvIsConn.setTextColor(Color.RED);
				        tvIsConn.setText("NOT Connected");
				        
				        isSocketConnected = false;
				        // û뵽socket˳Ҫȸʾ...
						//simpleDialogAndQuit("Connect failed","Please check your network...");
					}
					break;
				case ConstantData.EXCEPTION_STATUS:
					text = msg.getData().getString("Exception");
					Toast.makeText(WifiControlActivity.this, 
	    					text, 
	    					Toast.LENGTH_LONG).show();
					isSocketConnected = false;
					// û뵽socket˳Ҫȸʾ...
					//simpleDialogAndQuit("Connect failed","Please check your network...");
					break;

				case ConstantData.MSG_GET_RECV_INFO:
					//if(!isVerified)
					{
						text = msg.getData().getString("recvData");
						
						// ȡSSID/PWDϢ,app
						int ssid=0,pwd=1,macCypherHex=6,superCypherHex=7;//ch1=2,ch2=3,ch3=4,ch4=5,
						
						receiverInfo = getRecvData(text);
						SSID = receiverInfo[ssid];
						PWD = receiverInfo[pwd];
						strMacCypherHex = receiverInfo[macCypherHex];
						strSuperCypherHex = receiverInfo[superCypherHex];
						for(int i=0;i<ConstantData.MAX_CHANNEL_NUM;i++){
							failSafeValue[i]=Integer.parseInt(receiverInfo[i+2]);						
						}
						//int res = (int)jniEngineMain.verifyRx(tmpKey, strMacCypherHex, strSuperCypherHex);
						//if(0 == res){
							//Log.i("Verify result","Failure!!! ");
							//isVerified = false;
						//}else{
							//Log.i("Verify result","Success!!! ");
							//isVerified = true;
						//}
//						app.setIsVerified(isVerified);
//						if(!isVerified)
//						{
//							// û֤ɹ˳Ҫȸʾ...
//							simpleDialogAndQuit("Verify failed","Please check your reciever...");
//						}else{
//							//simpleDialog("debug info","Verify success!!");
//						}
						tvIsConn.setTextColor(Color.GREEN);
				        tvIsConn.setText(SSID);
						app.setRecvInfo(SSID, PWD);
						app.setFailsafe(failSafeValue,ConstantData.MAX_CHANNEL_NUM);
					}
					break;
				case ConstantData.MSG_GET_RECV_INFO_FAILED:	
					//if(!isVerified)
					{
						//Log.i("verify failed","verify getting result:"+text);
						// û֤ɹ˳Ҫȸʾ...
						//simpleDialogAndQuit("Verify failed","Please check your reciever...");
					}
					break;
				default:
					//Log.e("handler in main","receiving wrong message: "+String.valueOf(msg.what));
					break;
			}
			app.setIsWifiConnected(isSocketConnected); //ڴapp,лactivityʱ,
			super.handleMessage(msg);
		}
	};
	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle safedInstanceState) {  
    	super.onCreate(safedInstanceState);
    	this.requestWindowFeature(Window.FEATURE_NO_TITLE);//ȥ⣨Ӧõ) 
		//趨ҪдsetContentView֮ǰ쳣
		this.getWindow().setFlags(WindowManager.LayoutParams.FLAG_FULLSCREEN, WindowManager.LayoutParams.FLAG_FULLSCREEN);
		findView();
		activityName = "WifiControlActivity";
		
    }

	/*
	@Override
	protected void onActivityResult(int requestCode, int resultCode, Intent data){
		super.onActivityResult(requestCode, resultCode, data);
		Log.e("Mike","Info: WifiControlActivity.onActivityResult called");
	}
	*/
	
	@Override
	protected void onResume(){
		findView();
		app = ((ConnectWifiApplication) getApplicationContext());//ȫapplication
        currentPL = app.readCurrentProfile();//ȡǰ
				
		//õactivityʱ
        intent = this.getIntent();  
        activityName = intent.getStringExtra("fromActivity");
        if(activityName!=null){
	        if((activityName.equals("BasicControlActivity"))||
			(activityName.equals("BasicGLSurfaceViewActivity"))||
	        (activityName.equals("ReceiverEditActivity"))||
	        (activityName.equals("FailsafeEditActivity"))){
	        	//һķ
	        	socket = app.getCurServerSocket();
	        }
        }
        
        tvCurrentProfileName.setText(currentPL.strProfile);
        
        //֤ջ
        verify();
        
		super.onResume();
	}
	void findView(){
		setContentView(R.layout.main);
		btnEnterRecvEdit = (Button)findViewById(R.id.btnEnterRecvEdit);
        btnEnterRecvEdit.setOnClickListener(this);
        btnEnterRecvEdit.setTextColor(Color.CYAN);
        
        btnEnterFailsafeEdit = (Button)findViewById(R.id.btnEnterFailsafeEdit);
        btnEnterFailsafeEdit.setOnClickListener(this);
        btnEnterFailsafeEdit.setTextColor(Color.CYAN);
        
        btnEnterProfCfg = (Button)findViewById(R.id.btnEnterProfCfg);
        btnEnterProfCfg.setOnClickListener(this);
        btnEnterProfCfg.setTextColor(Color.CYAN);
        
        btnPlay = (Button) findViewById(R.id.Start);  
        btnPlay.setOnClickListener(this);
        btnExit = (Button) findViewById(R.id.ExitInMain);
        btnExit.setOnClickListener(this); 
        
        pbConnecting = (ProgressBar)findViewById(R.id.pbConnecting);
        pbConnecting.setVisibility(View.INVISIBLE);
		
        btnRefresh = (Button)findViewById(R.id.btnRefresh);
        btnRefresh.setOnClickListener(this);
        btnRefresh.setVisibility(View.VISIBLE);
                
        btnInstruction = (Button)findViewById(R.id.btnInstruction);
        btnInstruction.setTextColor(Color.CYAN);
        btnInstruction.setOnClickListener(this);
		
        // ý淵,ж״̬ȷǷӦʾnot connected
		tvIsConn = (TextView)findViewById(R.id.tvIsConn);
		app = ((ConnectWifiApplication) getApplicationContext());
		isSocketConnected = app.getIsWifiConnected();
		SSID = app.getSSID();
		if(isSocketConnected){
			tvIsConn.setTextColor(Color.GREEN);
			if(null!=SSID){
				tvIsConn.setText(SSID);
			}else{
				tvIsConn.setText("Connected");
			}
		}else{
			tvIsConn.setTextColor(Color.RED);
	        tvIsConn.setText("NOT Connected");
		}
		
		//Profile ļ
		tvCurrentProfileName = (TextView)findViewById(R.id.tvCurrentProfileName);
		tvCurrentProfileName.setTextColor(Color.CYAN);
		tvCurrentProfileName.setText(currentPL.strProfile);
	}
	
    @Override
	protected void onDestroy() {
    	super.onDestroy();
    	
    	// ֹsocket
    	isApplySocketThread = false;
    	if(threadApplySocket!=null){
			threadApplySocket.interrupt();
		}
    	
    	// رӵsocket
    	if(null != socket){
    		try{
    			socket.close();    			
    			isSocketConnected = false;
    			app.setIsWifiConnected(isSocketConnected);
    		}catch(Exception e){
    			//Log.e("Mike","failed to close socket in WifiControlActivity.java");
    		}
    	}
    	
    	// ֹϢ߳
    	if(mReceiveThread != null){
    		stopRecvMsg = true;
    	}
    	//android.os.Process.killProcess(android.os.Process.myPid()); //ǿɱý
	}
	
    void verify(){
    	/** 
         * ֤:
         *  1. WifiǷ,,ػ߽wifi;:
    	 *  2. ͼӣsocketʧ,ʾϢ,Ȼ󷵻;:
    	 *  3. ֤̣1ӽջȡ֤ϢջϢfailsafe.¼յϢ
    	 *  4. ֤ͨһճ
    	 *  5. ֤ʧܣ
    	 *  --ջϢfailsafeϢokʱapplicationͬʱҪRecvEditfailsafeactivity
    	 *  
    	 */
		// 1. wifi,δ,˳.һ              verify--У飬ȷ
    	//isVerified = app.getIsVerified();//֤
		//if(!isVerified)//֤̣
		{
	    	isWifiOn = checkNetworkInfo(); //wifiǷ.wifiӣʼsocket
			if(isWifiOn){
				// 2. ͼӣsocketʧ,ʾϢ,Ȼ˳. һ
				if((!isSocketConnected)&&(!isApplySocketThread)){
					threadApplySocket = new Thread(new threadApplySocket());
					isApplySocketThread = true;
					threadApplySocket.start();
					
					pbConnecting.setVisibility(View.VISIBLE);
			        btnRefresh.setVisibility(View.INVISIBLE);
			        
			        tvIsConn.setTextColor(Color.WHITE);
			        tvIsConn.setText("Connecting...");
				}			
			}
		}
    }
    @Override  
    protected void onPause()   
    {  
        super.onPause();  
        //رնԻ  
        //AlertDialog.dismiss();
        isApplySocketThread = false;
        if(threadApplySocket!=null){
			threadApplySocket.interrupt();
		}
    }

	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		if(btnPlay == v){
			// ͨsurfaceView½洦
	
			Intent intent0 = new Intent(WifiControlActivity.this, BasicControlActivity.class);
			Bundle bundle = new Bundle();  
			bundle.putString("fromActivity", "WifiControlActivity"); 
			intent0.putExtras(bundle);
			startActivity(intent0); 
//β ֱӽ 	BasicControlActivity	
			
//			if(isApplySocketThread){
//				simpleDialog("Tring to Connect","Connecting...");
//			}
////			else if(!isVerified)
////			{
////				simpleDialogAndQuit("Verify failed","Please check your reciever...");
////			}
//			else{
//				/*
//				if(!enterWithoutWifi){
//					//߳ wifi,socket
//					if((!isSocketConnected)&&(!isApplySocketThread)){
//						threadApplySocket = new Thread(new threadApplySocket());
//						isApplySocketThread = true;
//						threadApplySocket.start();
//						
//						pbConnecting.setVisibility(View.VISIBLE);
//				        btnRefresh.setVisibility(View.INVISIBLE);
//				        
//				        tvIsConn.setTextColor(Color.WHITE);
//				        tvIsConn.setText("Connecting...");
//					}
//				}
//				*/
//		        
//		        // ԲͬĲٿģʽ½
//		        if((ConstantData.BASIC_TOUCH_REV_MODE == currentPL.iControlMode)||
//		           (ConstantData.BASIC_RELATIVE_TOUCH_MODE == currentPL.iControlMode) ||
//		           (ConstantData.BASIC_TOUCH_MODE == currentPL.iControlMode)){
//		        	if(ConstantData.GL_SWITCH){
//		        		// GLSurfaceView½洦
//						Intent intent0 = new Intent(WifiControlActivity.this, BasicGLSurfaceViewActivity.class);
//						Bundle bundle = new Bundle();  
//						bundle.putString("fromActivity", "WifiControlActivity"); 
//						intent0.putExtras(bundle);
//						startActivity(intent0); 
//		        	}else{
//		        		// ͨsurfaceView½洦
//						Intent intent0 = new Intent(WifiControlActivity.this, BasicControlActivity.class);
//						Bundle bundle = new Bundle();  
//						bundle.putString("fromActivity", "WifiControlActivity"); 
//						intent0.putExtras(bundle);
//						startActivity(intent0); 
//		        	}
//					 
//		        }else if(ConstantData.SINGLE_BAR_MODE == currentPL.iControlMode){
//		        	Toast.makeText(WifiControlActivity.this, 
//		        					"control mode(single bar mode) not supported yet", 
//		        					Toast.LENGTH_LONG).show();
//		        }else if(ConstantData.GRAVITY_CONTROL_MODE == currentPL.iControlMode){
//		        	Toast.makeText(WifiControlActivity.this, 
//	    					"control mode(gravity control mode) not supported yet", 
//	    					Toast.LENGTH_LONG).show();
//		        }else if(ConstantData.MIX_CONTROL_MODE == currentPL.iControlMode){
//		        	Toast.makeText(WifiControlActivity.this, 
//	    					"control mode(mix control mode) not supported yet", 
//	    					Toast.LENGTH_LONG).show();
//		        }
//			}
			
		}else if(btnEnterProfCfg == v){
			if(isApplySocketThread){
				simpleDialog("Tring to Connect","Connecting...");
			}
//			else if(!isVerified)
//			{
//				simpleDialogAndQuit("Verify failed","Please check your reciever...");
//			}
			else{			
				// ûðťҳ
				Intent intent0 = new Intent(WifiControlActivity.this, ConfigAllActivity.class);
				Bundle bundle = new Bundle();  
	            bundle.putString("fromActivity", "WifiControlActivity");  
	            intent0.putExtras(bundle);
	    		startActivity(intent0);
			}

		}else if(btnExit == v){
			if(null != socket){
	    		try{
	    			socket.close();
	    		}catch(Exception e){
	    			//Log.e("Mike","failed to close socket in WifiControlActivity.java");
	    		}
	    	}
			isApplySocketThread = false;
			if(threadApplySocket!=null){
				threadApplySocket.interrupt();
			}
	    	android.os.Process.killProcess(android.os.Process.myPid());
			finish();
		}else if(btnRefresh == v){
			if(isApplySocketThread){
				simpleDialog("Tring to Connect","Connecting...");
			}
//			else if(!isVerified)
//			{
//				simpleDialogAndQuit("Verify failed","Please check your reciever...");
//			}
			else{
				//߳ wifi,socket
				if((!isSocketConnected)&&(!isApplySocketThread)){
					threadApplySocket = new Thread(new threadApplySocket());
					isApplySocketThread = true;
					threadApplySocket.start();
					
					pbConnecting.setVisibility(View.VISIBLE);
			        btnRefresh.setVisibility(View.INVISIBLE);
			        
			        tvIsConn.setTextColor(Color.WHITE);
			        tvIsConn.setText("Connecting...");
				}
				
				/**
				pbConnecting.setVisibility(View.VISIBLE);
		        btnRefresh.setVisibility(View.INVISIBLE);
				if(connectWifi()){
					pbConnecting.setVisibility(View.INVISIBLE);
			        btnRefresh.setVisibility(View.VISIBLE);
				}else{
					// ʧ
					dialogSimple("Info","Connect failed, please check wifi or firewall and try again...");
				}
				*/
			}
		}else if(btnEnterRecvEdit == v){
			if(isApplySocketThread){
				simpleDialog("Tring to Connect","Connecting...");
			}
//			else if(!isVerified)
//			{
//				simpleDialogAndQuit("Verify failed","Please check your reciever...");
//			}
			else{
				// û ༭ջ ťҳ
				Intent intent0 = new Intent(WifiControlActivity.this, ReceiverEditActivity.class);
				Bundle bundle = new Bundle();  
	            bundle.putString("fromActivity", "WifiControlActivity");  
	            intent0.putExtras(bundle);
	    		startActivity(intent0);
			}
		}else if(btnEnterFailsafeEdit == v){
			if(isApplySocketThread){
				simpleDialog("Tring to Connect","Connecting...");
			}
//			else if(!isVerified)
//			{
//				simpleDialogAndQuit("Verify failed","Please check your reciever...");
//			}
			else{
				//  ༭failSafe ťҳ
				Intent intent0 = new Intent(WifiControlActivity.this, FailsafeEditActivity.class);
				Bundle bundle = new Bundle();  
	            bundle.putString("fromActivity", "WifiControlActivity");  
	            intent0.putExtras(bundle);
	    		startActivity(intent0);
			}
		}else if(btnInstruction == v){
			if(isApplySocketThread){
				simpleDialog("Tring to Connect","Connecting...");
			}
//			else if(!isVerified)
//			{
//				simpleDialogAndQuit("Verify failed","Please check your reciever...");
//			}
			else{
				// ûinstruction,ҳ
				Intent intent0 = new Intent(WifiControlActivity.this, InstructionActivity.class);
				Bundle bundle = new Bundle();  
	            bundle.putString("fromActivity", "WifiControlActivity");  
	            intent0.putExtras(bundle);
	    		startActivity(intent0);
			}
		}
	}
	

	
	/**
	 * @author caro
	 * ʹù̶IP 192.168.20.20
	 * ̶˿ںţ8000
	 *
	 */
	public class threadApplySocket implements Runnable{
		int connectCount = 0;
		Message message;
		@Override
		public void run() {
			while (isApplySocketThread) {
				try {
			    	// 汾ش: ʹù̶ԶIP,ٴӽû. ʹû,Ҳֻrecv editṩ  mike 0701
			    	if((null == socket)||((null != socket)&&(true == socket.isClosed()))){
						try {
							InetAddress serverAddr = null;
							try{
								serverAddr = InetAddress.getByName(ConnectData.RECV_IP);
								socket =new Socket(serverAddr, ConnectData.TCP_PORT);
								socket.setSoTimeout(1000);
								socket.setTcpNoDelay(true);
								app.setCurServerSocket(socket);
								message=new Message();
								message.what=ConstantData.CONNECT_STATUS;
								message.getData().putBoolean("isConnect", true);
								handlerConnectMsg.sendMessage(message);
								//Log.d("Mike","Socket init OK!");
								isApplySocketThread = false;// Ͳ̼߳
							}catch(UnknownHostException hostE){
								message=new Message();
								message.what=ConstantData.EXCEPTION_STATUS;
								message.getData().putString("Exception", "Exception: the IP address lookup fails");
								handlerConnectMsg.sendMessage(message);
								isApplySocketThread = false;
								message = null; //
							}
						} catch (Exception e) {
							message=new Message();
							message.what=ConstantData.CONNECT_STATUS;
							message.getData().putBoolean("isConnect", false);
							handlerConnectMsg.sendMessage(message);
							e.printStackTrace();
							//Log.e("Mike","init socket err");
							message = null;
						}		
					}
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				connectCount++;
				if(connectCount>5) isApplySocketThread = false;// Ӳɹ5ΣͲ̼߳
			}
		}
	}
	
	// ȡ״̬,δwifiʱûwifi
    private boolean checkNetworkInfo()
    {
        ConnectivityManager conMan = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE); 
        //wifi
        State wifi = conMan.getNetworkInfo(ConnectivityManager.TYPE_WIFI).getState();        
                
        // wifiѾӣֱӷ        
        if(wifi==State.CONNECTED||wifi==State.CONNECTING)
        {	
        	return true;
        }
        
        //wifiδӣҲǴ״̬ ʾûֻеwifiýû 
        builder = new AlertDialog.Builder(WifiControlActivity.this);  
		builder.setTitle("Info"); 
		builder.setMessage("Wifi is OFF...Please set Wifi first..."); 
		
		
		// ṩֱӽwifi趨İť
		/*
		builder.setPositiveButton("wifi Setting",
				new DialogInterface.OnClickListener() {					
			        public void onClick(DialogInterface dialog,int whichButton){
			        	
			        	//ʱδ޸ãýдsharedPreferencesĶֱתwifiҳ
			        	startActivity(new Intent(Settings.ACTION_WIFI_SETTINGS));
			        	
			        	///////////////////////////////////////////////////////
			        	//ֱӴwifiӽջ
			        	Date d = null;
		        		long ms = 0;
		        		d=new Date();
		        		
		        		wifiManager = (WifiManager)WifiControlActivity.this.getSystemService(Context.WIFI_SERVICE); 
		        		WifiInfo mWifiInfo = wifiManager.getConnectionInfo();
		        		
		        		if (!wifiManager.isWifiEnabled()) {  
		        			wifiManager.setWifiEnabled(true);  
		                } 
		        		
		        		synchronized(lock){
		                	try {
		    					lock.wait(TIME);
		    				} catch (InterruptedException e) {
		    					// TODO Auto-generated catch block
		    					e.printStackTrace();
		    				}
		                }
		        		
		        		int netId;		        		
		        		netId = (mWifiInfo == null) ? INVALID_VALUE : mWifiInfo.getNetworkId();
		        		if((netId != INVALID_VALUE)||(netId != -1)){
			                wifiManager.disableNetwork(netId);  
			                wifiManager.disconnect(); 
		        		}
		                mWifiInfo = null; 
		        		// ɨ磬ҵջ硣 ɨֻԶ֮ǰ磬磬Ҫϵ
		        		//listResult = wifiManager.getScanResults();  
		        		listCfgResult = wifiManager.getConfiguredNetworks();
		        		int foundId = INVALID_VALUE;
		                if (listCfgResult != null) {  
		                    for (int i = 0; i < listCfgResult.size(); i++) {  
		                    	cfgResult = listCfgResult.get(i);
		                        if(cfgResult.SSID.equals("\"WifiRCReceiver (adhoc)\"")){
		                        	foundId = cfgResult.networkId;
		                        	break;
		                        }		                          
		                    }  
		                }else{
		                	Log.i("WifiӲοϢ","");
		                }
		                
		                if(foundId != INVALID_VALUE){
			                boolean b = wifiManager.enableNetwork(foundId, true);
			                Log.d("WifiӲοϢ", "enableNetwork  " + b);
			                
		                }else{
		                	// Ҳֱ磬ӣ
			            	WifiConfiguration wc = new WifiConfiguration();
			                wc.SSID = "\"WifiRCReceiver\"";      //wifiSSIDȵƣ磺TP-link_xxx
			                wc.preSharedKey = "\"12345\"";            //ȵ
			                wc.hiddenSSID = true;
			                wc.status = WifiConfiguration.Status.ENABLED;
			                wc.allowedGroupCiphers.set(WifiConfiguration.GroupCipher.TKIP);
			                wc.allowedGroupCiphers.set(WifiConfiguration.GroupCipher.CCMP);
			                wc.allowedKeyManagement.set(WifiConfiguration.KeyMgmt.WPA_PSK);
			                wc.allowedPairwiseCiphers.set(WifiConfiguration.PairwiseCipher.TKIP);
			                wc.allowedPairwiseCiphers.set(WifiConfiguration.PairwiseCipher.CCMP);
			                wc.allowedProtocols.set(WifiConfiguration.Protocol.RSN);
			                int res = wifiManager.addNetwork(wc);
			                Log.d("WifiӲοϢ", "add Network  " + res);
			                boolean b = wifiManager.enableNetwork(res, true);
			                Log.d("WifiӲοϢ", "enableNetwork  " + b);
			                wc = null;
		                }
		                //////////////////////////////////////////////////////
		            	
			        	dialog.cancel();}
			    });
		*/
		
		// ṩã˳İť
		builder.setNegativeButton("Exit",
				new DialogInterface.OnClickListener() {
	        		public void onClick(DialogInterface dialog,int whichButton){
	        			dialog.cancel();
	        			// ˳
	        			finish();
	        			android.os.Process.killProcess(android.os.Process.myPid());
	        		}
	    		});
		
		//ݲṩ˹:
		// ṩİťȻ򣬴ʱӲsocket
		/*
		builder.setNeutralButton("Skip wifi",
				new DialogInterface.OnClickListener() {
			        public void onClick(DialogInterface dialog,int whichButton){
			        	enterWithoutWifi = true;
			        	dialog.cancel();
			        	}
			    });
		*/
		alertDialog = builder.create();  
		alertDialog.show(); 
		
        return false;
    }

    /**
     * 
     * @param title
     * @param info
     */
    
    private void simpleDialog(String title,String info){		
		builder = new AlertDialog.Builder(WifiControlActivity.this);  
		builder.setTitle(title); 
		builder.setMessage(info); 
		
		builder.setPositiveButton("OK",
				new DialogInterface.OnClickListener() {
			        public void onClick(DialogInterface dialog,int whichButton){
                    dialog.cancel();}
			    });
		alertDialog = builder.create();  
		alertDialog.show();
	}
    
    /**
     * 
     * @param title
     * @param info
     */
    
    private void simpleDialogAndQuit(String title,String info){		
		builder = new AlertDialog.Builder(WifiControlActivity.this);  
		builder.setTitle(title); 
		builder.setMessage(info); 
		
		builder.setPositiveButton("OK",
				new DialogInterface.OnClickListener() {
			        public void onClick(DialogInterface dialog,int whichButton){
			        	dialog.cancel();
			        	onDestroy();					
                    }
			    });
		alertDialog = builder.create();  
		alertDialog.show();
	}
    
    /*ϢwifiԶ
	 * @param Socket socket, the socket that can send msg out
	 * @param String Msg, message to be send
	 */
	private void sendMsg(Socket socket,String Msg) throws IOException 
	{
		if(socket.isConnected()){
			writer = new BufferedWriter(
					new OutputStreamWriter(socket.getOutputStream()));
			writer.write(Msg); // ִʱעⲻ\n
			writer.flush();//ˢ¹ر
		}else{
			//Log.d("sendMsg failsafe","send message failed due to socket is not connected");
		}
	}
    
    
	private class ReceiveThread extends Thread
	{
	    private InputStream inStream = null;
	    
	    private byte[] buf;  
	    //private String str = null;
	    
	    ReceiveThread(Socket s)
	    {
	        try {
	            //
	            this.inStream = s.getInputStream();		            
	        } catch (IOException e) {
	            e.printStackTrace();
	        }
	    }      
	    
	    @Override
	    public void run()
	    {
	        while(!stopRecvMsg)
	        {
	            this.buf = new byte[512];
	            if((null != app.getCurServerSocket())&&(null != this.inStream))
	            {
	            	try {
	            		//ȡݣ
	            		while(-1 != this.inStream.read(this.buf)){
		            		// жϻõϢ, յջSSID/PWDϢ,Ϣhandler
		            		recvData=new String(this.buf,"UTF-8").trim();
		            		//recvData = this.buf.toString().trim();
		            		if(recvData.contains("Rxinfo:")){
		            			recvNullCount=0; //"δյݼ"
			            		msg= new Message();
			            		msg.what = ConstantData.MSG_GET_RECV_INFO;
			            		msg.getData().putString("recvData", recvData);
			            		handlerConnectMsg.sendMessage(msg);
			            		//Log.i("buf",buf.toString().trim());
		            		}else{
		            			msg= new Message();
			            		msg.what = ConstantData.MSG_GET_RECV_INFO_FAILED;
			            		handlerConnectMsg.sendMessage(msg);
		            		}
	            		}
	            	} catch (IOException e) {
	            		e.printStackTrace();
	            		if(recvNullCount < 3){
            				recvNullCount++;
            			}else{
            				recvNullCount=0;//"δյݼ"
            				msg= new Message();
		            		msg.what = ConstantData.MSG_GET_RECV_INFO_FAILED;
		            		handlerConnectMsg.sendMessage(msg);
            			}
	            	} 
	            }else{
	            	stopRecvMsg = true;
	            	//if(null == this.inStream)
	            		//Log.e("inStream null","inStream null");
	            	msg= new Message();
            		msg.what = ConstantData.MSG_GET_RECV_INFO_FAILED;
            		handlerConnectMsg.sendMessage(msg);
	            	break;
	            }
		    	
		    	// ÿ100msһ߳
		    	try {
					Thread.sleep(100);
				} catch (Exception ex) {
				}
	        }
	        
	        /*
	        if((stopRecvMsg)&&(null != this.inStream)){
				try {
					this.inStream.close();
					Log.i("inStream closed","Failsafe");
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
	        }
	        */
	    }  
	}
	

	/**
	 * ȡջssid,password,fail safeϢ
	 * @param recvData
	 * @return String[6],ssid,pwd,failsafe1,failsafe2,failsafe3,failsafe4
	 */
	private String[] getRecvData(String recvData){
		String tmpstr = recvData;
		int index,idxBegin,idxEnd;
		// recvDataʽӦΪ: "Rxinfo:ssid,key,1500,1500,1500,1500"
		index = tmpstr.indexOf(":");
		if(-1 == index){
			// Ҳ
			//Log.d("recv msg process","failed to find RX info prefix");
			return null;
		}
		idxBegin = index+1;
		String strArray[]= new String[8];
		int j;
		for(j=0;j<8;j++){
			idxEnd=tmpstr.indexOf(",",idxBegin);
			if(-1==idxEnd){
				idxEnd = tmpstr.length();
				strArray[j]=tmpstr.substring(idxBegin,idxEnd);
				break;
			}
			strArray[j]=tmpstr.substring(idxBegin,idxEnd);
			
			idxBegin = idxEnd+1;				
		}
		if(7>j){
			//Log.e("getSSIDFromRecvMsg","failed to find RX info ");
			return null;
		}
		return strArray;
	}
	
	char[] getTmpKey(){
		//ӵǰʱȡʱtmpKey֤
		String time = new String();
		char[] Key = {'1','2','3','4','5','6','7','8'};
		time = String.valueOf(new Date().getTime()).trim();
		if(time.length()>=8){
			time.getChars(0, 8, Key, 0);
		}else{
			
		}
		return Key;
	}
 
	


}
